/*
 * This is the thread routine for taking input from
 * the user and placing it into the chat buffer.
 */

#include <stdlib.h>
#include <stdio.h>
#include <strings.h>

#include "chat.h"

void AddToChatBuffer(struct chatbuff *G, struct linebuff *pMyLineBuff){
  int   mySlot ;
  mySlot = G->nextSlot ;
  INCRSLOT(&G->nextSlot) ;
  bcopy((void *)pMyLineBuff,(void *)&G->buff[mySlot],sizeof(struct linebuff));
}

void *InputFromUser(void *ptArgs) {
  struct chatbuff * volatile G ;
  int   mySock ;
  struct linebuff myLineBuff ;  
  struct timeval present ;
  int   userInputSize ;
  int   stillConnected ;
  FILE *sockIn ;

  mySock = ((struct ptGenericArg *)ptArgs) -> sock ;
  G      = ((struct ptGenericArg *)ptArgs) -> G ;
  free(ptArgs) ;

  if ((sockIn = fdopen(mySock, "r")) == (FILE *)NULL) {
    perror("fdopen") ;
    pthread_exit((void *)NULL) ;
  }

  stillConnected = 1 ;

  myLineBuff.status = MESSAGE ;
  while (stillConnected) {
    int nextC = 0 ;
    myLineBuff.size = 0 ;
    while (stillConnected && myLineBuff.size<CBUFFSIZE-1 && nextC != '\n') {
      if ((nextC=fgetc(sockIn)) != EOF) {
	myLineBuff.buff[myLineBuff.size] = nextC ;
	++myLineBuff.size ;
      } else
	stillConnected = 0 ;
    }
    if (stillConnected) {
      gettimeofday(&present, (struct timezone *)NULL) ;
      myLineBuff.created = present.tv_sec ;
#ifdef DEBUG
      myLineBuff.buff[myLineBuff.size] = '\0';
      printf("New line %*s", myLineBuff.size, myLineBuff.buff) ;
#endif
      AddToChatBuffer(G, &myLineBuff) ;    
    }
  }

  return ((void *)NULL) ;
}
